



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>三、线程同步之Sysnchronized关键字</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">三、线程同步之Sysnchronized关键字</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 12:42:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>线程同步</h4>
<h5>问题引入</h5>
<div>观察一面一段小程序：</div>
<div>
<div>
<pre class="prettyprint linenums">
<ol><li><code>public class Main {</code></li>
<li><code></code></li>
<li><code>	private static int amount = 0;</code></li>
<li><code></code></li>
<li><code>	public static void main(String[] args) {</code></li>
<li><code>		System.out.println(++amount);</code></li>
<li><code>		new MyThread("thread1").start();</code></li>
<li><code>		new MyThread("thread2").start();</code></li>
<li><code>	}</code></li>
<li><code>	</code></li>
<li><code>	private static void calc(String tag){</code></li>
<li><code>		++amount;</code></li>
<li><code>		try {</code></li>
<li><code>			Thread.sleep(1);</code></li>
<li><code>		} catch (InterruptedException e) {</code></li>
<li><code>			e.printStackTrace();</code></li>
<li><code>		}</code></li>
<li><code>		System.out.println(tag + "==&gt;" + amount);</code></li>
<li><code>	}</code></li>
<li><code></code></li>
<li><code>	static class MyThread extends Thread {</code></li>
<li><code></code></li>
<li><code>		private String name;</code></li>
<li><code></code></li>
<li><code>		public MyThread(String name) {</code></li>
<li><code>			super();</code></li>
<li><code>			this.name = name;</code></li>
<li><code>		}</code></li>
<li><code></code></li>
<li><code>		@Override</code></li>
<li><code>		public void run() {</code></li>
<li><code>			super.run();</code></li>
<li><code>			calc(name);</code></li>
<li><code>		}</code></li>
<li><code>	}</code></li>
<li><code>}</code></li></ol>
</pre>
</div>
<div>运行结果：<br></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1088097/201612/1088097-20161229105844226-375325526.png"></div>
<div>
<div>上面的代码MyThread中先将amount累加1；再睡1S，打印数据。很显然thread1睡眠之后被打断，thread2被执行才会出现这样的情况。</div>
<div>系统对线程的调度是有一定随机性的。当多线程操作资源时，才会出现线程安全的问题。Java 提供了一系列的方案来解决这个问题，下面将一一说明。</div>
<h5>Synchronized关键字</h5>
<div>
<h6>同步方法块</h6>
<div>
<pre class="prettyprint linenums">
<ol><li><code>synchronized(obj){</code></li>
<li><code>		...	</code></li>
<li><code> &nbsp; &nbsp; &nbsp; &nbsp;//此处是同步代码块<br></code></li>
<li><code>}</code></li></ol>
</pre>
</div>
<div>当线程执行此段代码时必须持有锁，否则不能执行，上面代码修改如下所示即可恢复正常：</div>
<div>
<div>
<pre class="prettyprint linenums">
<ol><li><code>    //对象锁</code></li>
<li><code>	private static Object obj = new Object();</code></li>
<li><code></code></li>
<li><code>	private static void calc(String tag) {</code></li>
<li><code>		//执行此代码必须持有此锁，没有锁只能等待此锁的使用线程释放锁</code></li>
<li><code>		synchronized (obj) {</code></li>
<li><code>			++amount;</code></li>
<li><code>			try {</code></li>
<li><code>				Thread.sleep(1);</code></li>
<li><code>			} catch (InterruptedException e) {</code></li>
<li><code>				e.printStackTrace();</code></li>
<li><code>			}</code></li>
<li><code>			System.out.println(tag + "==&gt;" + amount);</code></li>
<li><code>		}</code></li>
<li><code>	}</code></li></ol>
</pre>
</div>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1088097/201612/1088097-20161229105844648-747423310.png"><br></div>
<div>
<h6>同步方法</h6>
<div>此关键字还可以直接修饰方法，被修饰的方法为同步方法。同步方法的使用也必须持有锁，此时锁定的是this(当前对象)，</div>
<div>
<pre class="prettyprint linenums">
<ol><li><code>private synchronized static void calc(String tag) {</code></li>
<li><code>		// 执行此代码必须持有此锁，没有锁只能等待此锁的使用线程释放锁</code></li>
<li><code>		++amount;</code></li>
<li><code>		try {</code></li>
<li><code>			Thread.sleep(1);</code></li>
<li><code>		} catch (InterruptedException e) {</code></li>
<li><code>			e.printStackTrace();</code></li>
<li><code>		}</code></li>
<li><code>		System.out.println(tag + "==&gt;" + amount);</code></li>
<li><code>	}</code></li></ol>
</pre>
</div>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1088097/201612/1088097-20161229105844914-24577165.png"></div>
<h6>释放锁</h6>
<div>&nbsp; &nbsp;synchronized修饰的代码块或者同步方法没有显性的释放锁的方法。遇到以下几种情况会释放锁。</div>
<div>
<ul><li>使用synchronized关键字，必须等待当前线程执行完同步代码块或者同步方法，锁被释放。</li>
<li>遇到return、break终止了当前代码块或者同步方法，锁被释放。</li>
<li>遇到未处理的异常导致的崩溃，当前锁被释放。</li>
<li>线程调用wait方法，释被放锁。</li></ul>
<div>下面两点不会释放锁，需要注意：</div>
<div>
<ul><li>程序调用Thread.sleep()、Thread.yield(),当前线程不会释放锁。</li>
<li>其他线程调用suspend方法，将此方法挂起，当前线程不会释放锁。同时应该避免使用suspend和resume方法控制线程。</li></ul>
</div>
</div>
<div>
<h6>访问权限总结</h6>
<div>访问权限原则：当前线程持有某个锁时，其他线程无法访问被同一个锁锁定的方法或者代码块；与是否在一个类中，是否是静态无关，只与锁是否被释放有关。</div>
<div>常见的问题如下：</div>
<div>
<ul><li>一个类中，有多个方法，当前线程持有某锁，其他线程无法访问此锁锁定的其他同步方法，但是可以访问其他非同步方法</li>
<li>一个类中有多个代码块或同步方法，当前线程持有某所，其他线程可以访问其他锁锁定的同步代码块</li></ul>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
<div><a href="http://www.wiz.cn/i/ba601c39" rel="external nofollow noreferrer">null</a></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwddxy8.html">android图片验证码--自绘控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pj5g79.html">php 使用函数中遇到的坑之----list</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7epjx9.html">Python【第二章】：Python的数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mlv529.html">UVa 10917 Dijkstra</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qygyvxq.html">winserver2008 R2 64位 企业版 &comma; IIS 配置运行 asp&plus;access 网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k40r39.html">Altera SoC与Matlab的联合---第一步 软件安装与硬件测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwymdl8.html">Firefox刷新页面和复选框的奇葩问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1ekwm9.html">移动端web出现的一系列问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xdnxw9.html">Cocos2d-android &lpar;04&rpar; 执行多个动作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okgve19.html">c&plus;&plus; void，内存操作函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnz3l6q.html">移动Web开发图片自适应两种常见情况解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdpv3r8.html">postgresql9&period;4新特性jsonb学习-update更新操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xrvog9.html">C&num;  StringExt  字符串扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okzvpp9.html">Android  DatePickerDialog 只选择年月</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljol309.html">C&sol;C&plus;&plus;语言的标准库函数malloc&sol;free与运算符new&sol;delete的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojvd75q.html">&lbrack;Unity UGUI&rsqb;UGUI提供多种不同的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me6d70q.html">【动态规划】记忆搜索（C&plus;&plus;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyz0kk9.html">安卓获取自有证书的SHA1码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvvvez8.html">BZOJ4720-换教室</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyyz1n9.html">Mybatis&lpar;六&rpar; Spring整合mybatis</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49gm7gl9.html">翻书插件：wowbook&period;js</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7m5ygq.html">CCS应用中常见的一些小技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ok6xp9.html">excellent cushioning and also vitality go back with this boot</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlmg1k9.html">Digester组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8okzo19.html">TinyFox&sol;Jexus如何正确使用配置文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn13vj8.html">JavaScript闭包浅谈</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdemkz9.html">Java学习过程中的总结的小知识点（长期更新）</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4ye15q.html">JS阻止冒泡事件以及默认事件发生的简单方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93x0zw9.html">Java开源库</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8eye0k9.html">UvaLA 3938 &amp;quot&semi;Ray&comma; Pass me the dishes&excl;&amp;quot&semi;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
